<!DOCTYPE html>
<html lang="en">
<head>
    <title>Task 36.50 Get User Api Load dataTable</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách người dùng</h2>
        
        <table id="user-table" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Mã người dùng</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            
          </tbody>
        </table>
      </div>
</body>
<script>
    "use strict";
    $(document).ready(function(){
        //REGION 1
        const gDATA_COLUMN = [ //gán với các tên cột của mảng
            "id", "firstname" ,"lastname", "country", "subject", "customerType", "registerStatus", "action"
        ];
        const gUSER_ID_COL = 0;
        const gFIRST_NAME_COL = 1;
        const gLAST_NAME_COL = 2;
        const gCOUNTRY_COL = 3;
        const gSUBJECT_COL = 4;
        const gCUSTOMER_TYPE_COL = 5;
        const gREGISTER_STATUS_COL = 6;
        const gACTION_COL = 7;

        $("#user-table").DataTable({
                "columns": [
                    {"data": gDATA_COLUMN[gUSER_ID_COL]},
                    {"data": gDATA_COLUMN[gFIRST_NAME_COL]},
                    {"data": gDATA_COLUMN[gLAST_NAME_COL]},
                    {"data": gDATA_COLUMN[gCOUNTRY_COL]},
                    {"data": gDATA_COLUMN[gSUBJECT_COL]},
                    {"data": gDATA_COLUMN[gCUSTOMER_TYPE_COL]},
                    {"data": gDATA_COLUMN[gREGISTER_STATUS_COL]},
                    {"data": gDATA_COLUMN[gACTION_COL]}
                ],
                columnDefs: [ //định nghĩa các cột cần hiện ra
                    {
                        targets: gACTION_COL,
                        defaultContent: "<button class=\'btn btn-info btn-detail'\>Chi tiết</button>"
                    }
                ]
            });
        //REGION 2
        onPageLoading();

        $(document).on("click", "#user-table .btn-detail", function(){
            onBtnDetailClick(this);
        })
        //REGION 3
        function onPageLoading(){
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
                type: "GET",
                dataType: "json",
                success: function(response){
                    console.log(response);
                    loadDataToTable(response)
                },
                error: function(ajaxContext){
                    alert(ajaxContext.reponseText);
                }
            });
        }
        //hàm load dữ liệu vào table
        function loadDataToTable(paramResponse){
            "use strict";
            var vTable = $("#user-table").DataTable(); //tạo biến tuy xuất dataTable
            vTable.clear();
            vTable.rows.add(paramResponse);
            vTable.draw();
        }
        //hàm sử lý sự kiện nút detail click
        function onBtnDetailClick(paramEvent){
            "use strict";
            var vRowClick = $(paramEvent).parents("tr") //xác định parent tr chưa nút bấm được click
            var vTable = $("#user-table").DataTable() // tạo biến truy xuất dataTable
            var vDataRow = vTable.row(vRowClick).data() //lấy dữ liệu của hàng chứa nút bấm được click
            console.log("User id: " + vDataRow.id);
            console.log("First name: " + vDataRow.firstname);
            console.log("Last name: " + vDataRow.lastname);
            console.log("country: " + vDataRow.country);
            console.log("Subject: " + vDataRow.subject);
            console.log("Custumer Type: " + vDataRow.customerType);
            console.log("Register Status: " + vDataRow.registerStatus);
        }
        //REGION 4
        
    });
</script>
</html>